unit ShellViewFormUnit;

interface

uses
    Windows,
    Messages,
    SysUtils,
    Classes,
    Graphics,
    Controls,
    Forms,
    Dialogs,
    SxShellViewForm,
    SxProvider, StdCtrls, ComCtrls, SxShellListControl, ExtCtrls, ImgList;

type
  TAbstractShellViewForm = class(TSxShellViewForm)
    ImageList1: TImageList;
    ListView: TListView;
    Panel: TPanel;
    procedure SxShellViewFormClearItems(Sender: TObject);
    procedure SxShellViewFormProcessItems(Sender: TSxShellViewForm;
      CurrentProvider: TSxCustomProvider; DataGrains: TSxDataGrainList);
    procedure ListViewDblClick(Sender: TObject);
    procedure ListViewDeletion(Sender: TObject; Item: TListItem);
    procedure ListViewSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TAbstractShellViewForm.SxShellViewFormClearItems(
  Sender: TObject);
begin
  ListView.Items.Clear;
end;

procedure TAbstractShellViewForm.SxShellViewFormProcessItems(
  Sender: TSxShellViewForm; CurrentProvider: TSxCustomProvider;
  DataGrains: TSxDataGrainList);
var
  i:Integer;
  ListItem:TListItem;
  currentRootGrain:TSxCustomDataGrain;
begin
  currentRootGrain:=ShellFolder.GetFolderGrain;
  try
    Panel.Caption:='Current folder is: '+currentRootGrain.Name;
  finally
    ShellFolder.ReleaseDataGrain(currentRootGrain);
  end;
  for i:=0 to DataGrains.Count-1 do
  begin
    ListItem:=ListView.Items.Add;
    ListItem.Caption:=DataGrains[i].Name;
    ListItem.Data:=DataGrains[i].Clone;
    if DataGrains[i].GrainType=gtFolder then
       ListItem.ImageIndex:=0
    else
       ListItem.ImageIndex:=1;
  end;
end;

procedure TAbstractShellViewForm.ListViewDblClick(Sender: TObject);
begin
  if ListView.Selected<>nil then
     ExploreDataGrain(ListView.Selected.Data)
end;

procedure TAbstractShellViewForm.ListViewDeletion(Sender: TObject;
  Item: TListItem);
begin
  if Item.Data<>nil then
  begin
    TSxCustomDataGrain(Item.Data).Free;
    Item.Data:=nil;
  end;
end;

procedure TAbstractShellViewForm.ListViewSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if Selected then
     SelectedDataGrain:=TSxCustomDataGrain(Item.Data)
  else
     SelectedDataGrain:=nil;
end;

initialization
  RegisterShellViewFormClass(TAbstractShellViewForm);
end.
 

 
